#ifndef CSTREE_H
#define CSTREE_H

#include "set.h"
#include "ordering.h"
#include "config.h"
//#include "queue.h"
#include "rtree.h"

typedef struct STNode_s STNode;

struct STNode_s
{
	int noOfChild;

	STNode **child;

	int classNo;
	int dimNo;

	mySet *P_head;
	mySet *P_tail;
	mySet *P_tail2;
	mySet *S;
	mySet *totalS;

	STNode *nestedTree;

	mySet *processingClass;

	mySet *nodeOrdering;
	myOrderSet *anOrderSet;
};

//extern int isDominate_ordering(record *rec1, record *rec2, int noOfNumAttr, int dimNo, mySet *anOrdering);
extern int isDominate_ordering(record *rec1, record *rec2, int noOfNumAttr, myOrderSet *anOrderSet);
extern void set_intersection_classSet(config *aConfig, mySet *set1, mySet *set2, myClassSet *set1Class, myClassSet *set2Class, myClassSet *intersectClass);

STNode *STNode_new();
void STNode_free(STNode *aSTNode);

//void CSNode_compress(STNode *root);
//void CSNode_analyzeSize(STNode *root, int *noOfNode, int *noOfDataPoint, int *noOfDataPointInPTail);
void STNode_printTree(FILE *filePtr, STNode *aSTNode, char *prefix);

void CSNode_findSkylineInCST_internal(mySet *skylineSet, mySet *totalP_tail, STNode *root, config *aConfig, myOrderSet *anOrderSet, int orderSetIndex, int **addFlag);

STNode *CSNode_BFS(record *data, config *aConfig, int dimNo, mySet *remainD, mySet *globalSkyline, rtreeGroup *anRtreeGroup, myOrderSet *anOrderSet, myClassSet *projDimClass);

mySet *CSNode_findSkylineInCST(STNode *root, config *aConfig, myOrderSet *anOrderSet);
//void CSNode_findSkylineInCST_internal(mySet *skylineSet, mySet *totalP_tail, STNode *root, config *aConfig, myOrderSet *anOrderSet);
//void CSNode_findSkylineInCST_internal(mySet *skylineSet, mySet *totalP_tail, STNode *root, config *aConfig, myOrderSet *anOrderSet, int orderSetIndex);

void STNode_freeAll(STNode *aSTNode);

//STNode *CSNode_BFS(record *data, config *aConfig, int dimNo, mySet *remainD, mySet *globalSkyline, rtreeGroup *anRtreeGroup, myOrderSet *anOrderSet);
void CSNode_compress(STNode *root, int noOfDim);

mySet *CSNode_findSkylineInPartialOrder(STNode *root, config *aConfig, int dimNo, mainOrdering *mainPartialOrder);

void CSNode_analyzeSize(STNode *root, int *noOfNode, int *noOfDataPointInS, int *noOfDataPointInPTail, int levelNo, int noOfCat);

int CSNode_checkValidOrderingWhole(config *aConfig, myClassSet *aClassSet);

#endif
