
#include "disqualify.h"
#include "ordering.h"
#include "set.h"

myClassSet *getCatClassComparison(config *aConfig, record *rec1, record *rec2)
{
	myClassSet *returnValue;

	int i;

	int noOfNumAttr;

	int classNo1, classNo2;

	int dimNo;

	noOfNumAttr = aConfig->noOfDim - aConfig->noOfCat;

	returnValue = classSet_new();

	for (i = 0; i < aConfig->noOfCat; i++)
	{
		dimNo = i+noOfNumAttr;

		classNo1 = rec1->content[dimNo];
		classNo2 = rec2->content[dimNo];

		//*** NEW
		if (classNo1 != classNo2)
		{
			classSet_insert(returnValue, dimNo, classNo1);
			classSet_insert(returnValue, dimNo, classNo2);
		}
	}

	return returnValue;
}

mySet *disqualify_findSkyline(myClassSetSetSet *disqSet, config *aConfig, mainOrdering *aMainOrdering)
{
	mySet *returnValue;

	int i, j;

	int pointID;

	int isContain;

	int noOfNumAttr;

	int isSkyline;

	FILE *filePtr;
	char *filename = "progress.txt";


	myClassSetSet *aDisqSet;

	noOfNumAttr = aConfig->noOfDim - aConfig->noOfCat;

	returnValue = set_new();

	filePtr = (FILE *) fopen(filename, "w");
	if (filePtr == NULL)
	{
		printf("File %s cannot be opened!\n", filename);
		exit(0);
	}
fprintf(filePtr, "%d\n", disqSet->noOfElt);
	//printf("Node visited: %d\n", disqSet->noOfElt);
	for (i = 0; i < disqSet->noOfElt; i++)
	{

		aDisqSet = disqSet->elt[i];
		pointID = disqSet->pointID[i];

if (pointID == 172)
{
	printf("");
}

		isSkyline = 1;
		for (j = 0; j < aDisqSet->noOfElt; j++)
		{
			// if one of elts in aDisqSet matches anOrderSet
			// if yes, it is not a skyline
			// otherwise, it is a skyline

			isContain = mainOrdering_isContain_disqualify(noOfNumAttr, aMainOrdering, aDisqSet->elt[j]);
			if (isContain == 1)
			{
				// not
				isSkyline = 0;
				break;
			}
			else
			{
				//
				// do nothing
			}
		}

fprintf(filePtr, "%d\n", isSkyline);
		if (isSkyline == 1)
		{
			set_insert(returnValue, pointID);
		}
	}
fprintf(filePtr, "%d\n", returnValue->noOfElt);
	fclose(filePtr);

	return returnValue;
}

void disqualify_print(FILE *filePtr, myClassSetSetSet *disqSet)
{
	int noOfElt;

	int i, j, k;

	int *pointID;
	myClassSetSet **elt;

	int eltNo0, eltNo1;

	myClassSet *aClassSet;

	noOfElt = disqSet->noOfElt;

	elt = disqSet->elt;
	pointID = disqSet->pointID;

	for (i = 0; i < noOfElt; i++)
	{
		fprintf(filePtr, "Point ID: %d\n", pointID[i]);

		
		for (j = 0; j < elt[i]->noOfElt; j++)
		{
			fprintf(filePtr, "  %d. ", j);
			aClassSet = elt[i]->elt[j];
			for (k = 0; k < aClassSet->noOfElt; k++)
			{
				fprintf(filePtr, "(DimNo:%d) ", aClassSet->dimNo[k]);

				eltNo0 = aClassSet->list[k]->elt[0];
				eltNo1 = aClassSet->list[k]->elt[1];

				fprintf(filePtr, "%d < %d", eltNo0, eltNo1);

				if (k != aClassSet->noOfElt-1)
				{
					fprintf(filePtr, " and ");
				}
			}
			fprintf(filePtr, "\n");
		}
	}
}

void disqualify_getStorage(myClassSetSetSet *disqSet, int *noOfDataPoint, int *noOfCondition, int *noOfDominatingElt)
{
	int noOfElt;

	int i, j, k;

	int *pointID;
	myClassSetSet **elt;

	int eltNo0, eltNo1;

	myClassSet *aClassSet;


	noOfElt = disqSet->noOfElt;

	elt = disqSet->elt;
	pointID = disqSet->pointID;

	(*noOfDataPoint) = noOfElt;
	(*noOfCondition) = 0;
	(*noOfDominatingElt) = 0;

	for (i = 0; i < noOfElt; i++)
	{
		//fprintf(filePtr, "Point ID: %d\n", pointID[i]);

		
		for (j = 0; j < elt[i]->noOfElt; j++)
		{
			(*noOfCondition)++;
			//fprintf(filePtr, "  %d. ", j);
			aClassSet = elt[i]->elt[j];

			(*noOfDominatingElt) += aClassSet->noOfElt;
			for (k = 0; k < aClassSet->noOfElt; k++)
			{
				//fprintf(filePtr, "(DimNo:%d) ", aClassSet->dimNo[k]);

				eltNo0 = aClassSet->list[k]->elt[0];
				eltNo1 = aClassSet->list[k]->elt[1];

				//fprintf(filePtr, "%d < %d", eltNo0, eltNo1);

				if (k != aClassSet->noOfElt-1)
				{
					//fprintf(filePtr, " and ");
				}
			}
			//fprintf(filePtr, "\n");
		}
	}
}

//mySet *disqualify_findSkyline(myClassSetSetSet *disqSet, config *aConfig, mainOrdering *aMainOrdering)
//myClassSetSet *disqualify_findDisqualifying(myClassSetSetSet *disqSet, int point ID, config *aConfig)
myClassSetSet * disqualify_findDisqualifying(myClassSetSetSet *disqSet, int pointID, config *aConfig)
{
	myClassSetSet *returnValue;

	int i;

	returnValue = classSetSet_new();

	for (i = 0; i < disqSet->noOfElt; i++)
	{
		if (pointID == disqSet->pointID[i])
		{
			classSetSet_clone(returnValue, disqSet->elt[i]);
			return returnValue;
		}
	}

	return returnValue;
}

void disqualify_printDisqCond(FILE *filePtr, myClassSetSet *disqCond)
{
	int i, j; //, k;

	myClassSet **elt;

	mySet *list;

	int dimNo;

	int noOfElt;

	noOfElt = disqCond->noOfElt;
	elt = disqCond->elt;

	for (i = 0; i < noOfElt; i++)
	{
		fprintf(filePtr, "[");
		for (j = 0; j < elt[i]->noOfElt; j++)
		{
			dimNo = elt[i]->dimNo[j];
			list = elt[i]->list[j];

			fprintf(filePtr, "(DimNo: %d) ", dimNo);
			fprintf(filePtr, "%d < %d", list->elt[0], list->elt[1]);

			if (j != elt[i]->noOfElt-1)
			{
				fprintf(filePtr, " and ");
			}
		}
		fprintf(filePtr, "]\n");

		if (i != noOfElt-1)
		{
			fprintf(filePtr, " or ");
		}
	}
}



void disqualifyImplicitPref_main(config *aConfig, myClassSetSetSet *disqualifySet, FILE *debugFilePtr, FILE *timeFilePtr)
{
	mySetSet *RR;
	mainOrdering *R;

	int i, j;

	int *index;
	int *elt;

	mySet *skylineSet;

	int disq_noOfDataPoint, disq_noOfCondition, disq_noOfDominatingElt;
	int storageSize;

#ifndef WIN32
	struct rusage query_start;
	struct rusage query_end;
	float query_u;
	float query_s;
#endif

#ifndef WIN32
	getrusage(RUSAGE_SELF, &query_start);
#endif

	RR = config_readPreference(aConfig);
	//R = mainOrdering_transformPartialOrder2MainOrdering(aConfig->noOfClass, RR);

	for (i = 0; i < aConfig->noOfFullOrderQuery; i++)
	{
		R = mainOrdering_transformPartialOrder2MainOrdering(aConfig->noOfClass, RR);

		skylineSet = disqualify_findSkyline(disqualifySet, aConfig, R);

		if (skylineSet->noOfElt > 0)
		{
			index = (int *) malloc(sizeof(int)*skylineSet->noOfElt);
			elt = (int *) malloc(sizeof(int)*skylineSet->noOfElt);
			memcpy(elt, skylineSet->elt, sizeof(int)*skylineSet->noOfElt);
			for (j = 0; j < skylineSet->noOfElt; j++)
			{
				index[j] = j;
			}
			quicksort_i(index, elt, 0, skylineSet->noOfElt-1);
			for (j = 0; j < skylineSet->noOfElt; j++)
			{
				skylineSet->elt[j] = elt[skylineSet->noOfElt-1-j];
			}
			free(index);
			free(elt);
		}

		printf("Skyline (%d): ", skylineSet->noOfElt);
		set_print(stdout, skylineSet);
		printf("\n");

		set_free(skylineSet);
		free(skylineSet);

		mainOrdering_free(R);
		free(R);
	}

#ifndef WIN32
	getrusage(RUSAGE_SELF, &query_end);

#endif

	disqualify_getStorage(disqualifySet, &disq_noOfDataPoint, &disq_noOfCondition, &disq_noOfDominatingElt);

	storageSize = disq_noOfDataPoint*4 + disq_noOfCondition*4 + disq_noOfDominatingElt*8;

	printf("Storage\n");
	printf("storageSize: %d\n", storageSize);
	printf("noOfDataPoint: %d\n", disq_noOfDataPoint);
	printf("noOfCondition: %d\n", disq_noOfCondition);
	printf("noOfDominatePt: %d\n", disq_noOfDominatingElt);

	fprintf(debugFilePtr, "0\n");
	fprintf(debugFilePtr, "%d\n", storageSize);
	fprintf(debugFilePtr, "%d\n", disq_noOfDataPoint);
	fprintf(debugFilePtr, "%d\n", disq_noOfCondition);
	fprintf(debugFilePtr, "%d\n", disq_noOfDominatingElt);
	
#ifndef WIN32
	calculateExecutionTime(&query_start, &query_end, &query_u, &query_s);
	query_u /= aConfig->noOfFullOrderQuery;
	query_s /= aConfig->noOfFullOrderQuery;

	printf("Query Time: %.10f\t%.10f\n", query_u, query_s);

	fprintf(timeFilePtr, "0\t0\n");
	fprintf(timeFilePtr, "%.10f\t%.10f\n", query_u, query_s);
#endif


}

