#include "ordering.h"
#include "set.h"

binaryOrder *binaryOrder_new()
{
	binaryOrder *returnValue;

	returnValue = (binaryOrder *) malloc(sizeof(binaryOrder));
	memset(returnValue, 0, sizeof(binaryOrder));

	return returnValue;
}

ordering *ordering_new()
{
	ordering *returnValue;

	returnValue = (ordering *) malloc(sizeof(ordering));
	memset(returnValue, 0, sizeof(ordering));

	return returnValue;
}

ordering *ordering_clone(ordering *anOrdering)
{
	ordering *returnValue;

	binaryOrder *orderList;
	binaryOrder *orderList_new;

	returnValue = ordering_new();

	orderList = anOrdering->orderList;

	returnValue->noOfBinaryOrder = anOrdering->noOfBinaryOrder;
	orderList_new = (binaryOrder *) malloc(sizeof(binaryOrder)*returnValue->noOfBinaryOrder);
	memcpy(orderList_new, orderList, sizeof(binaryOrder)*returnValue->noOfBinaryOrder);
	returnValue->orderList = orderList_new;

	return returnValue;
}

void ordering_free(ordering *anOrdering)
{
	if (anOrdering->noOfBinaryOrder > 0)
	{
		free(anOrdering->orderList);
	}
}

//ordering_isContain(anOrdering, classID, classID2);
int ordering_isContain(ordering *anOrdering, int classID, int classID2)
{
	int returnValue;

	binaryOrder *aBinaryOrder;

	int classBefore, classAfter;

	int i;

	returnValue = 0;
	for (i = 0; i < anOrdering->noOfBinaryOrder; i++)
	{
		aBinaryOrder = &(anOrdering->orderList[i]);
		classBefore = aBinaryOrder->classBefore;
		classAfter = aBinaryOrder->classAfter;

		if ((classBefore == classID) && (classAfter == classID2))
		{
			returnValue = 1;
			break;
		}
	}

	return returnValue;
}

void ordering_insertBinaryOrder2Ordering(ordering *anOrdering, int classBefore, int classAfter)
{
	int noOfBinaryOrder;

	//binaryOrder *binOrder;

	//binOrder = binaryOrder_new();

	//binOrder->classBefore = classBefore;
	//binOrder->classAfter = classAfter;

	noOfBinaryOrder = anOrdering->noOfBinaryOrder;
	if (noOfBinaryOrder == 0)
	{
		anOrdering->orderList = (binaryOrder *) malloc(sizeof(binaryOrder));
	}
	else
	{
		anOrdering->orderList = (binaryOrder *) realloc(anOrdering->orderList, sizeof(binaryOrder)*(noOfBinaryOrder+1));
	}
	anOrdering->orderList[noOfBinaryOrder].classBefore = classBefore;
	anOrdering->orderList[noOfBinaryOrder].classAfter = classAfter;

	anOrdering->noOfBinaryOrder++;

	
}



void binaryOrder_printBinaryOrder_coarse(FILE *filePtr, binaryOrder *aBinaryOrder)
{
	fprintf(filePtr, "%d < %d", aBinaryOrder->classBefore, aBinaryOrder->classAfter);
}

void ordering_printOrdering(FILE *filePtr, ordering *anOrdering)
{
	int noOfBinaryOrder;
	binaryOrder *orderList;

	int i;

	noOfBinaryOrder = anOrdering->noOfBinaryOrder;
	orderList = anOrdering->orderList;

	fprintf(filePtr, "[");
	for (i = 0; i < noOfBinaryOrder; i++)
	{
		binaryOrder_printBinaryOrder_coarse(filePtr, &(orderList[i]));

		if (i != noOfBinaryOrder-1)
		{
			fprintf(filePtr, " or ");
		}
	}
	fprintf(filePtr, "]");
}

mySet *ordering_findStart_LinearOrdering(ordering *anOrdering)
{
	mySet *returnValue;

	int noOfBinaryOrder;
	binaryOrder *orderList;

	int eltNo1, eltNo2;

	int i, j;

	int isInDegreeZero;

	returnValue = set_new();

	noOfBinaryOrder = anOrdering->noOfBinaryOrder;
	orderList = anOrdering->orderList;

	// count the "classBefore" with in-degree 0
	for (i = 0; i < noOfBinaryOrder; i++)
	{
		isInDegreeZero = 1;
		eltNo1 = orderList[i].classBefore;

		for (j = 0; j < noOfBinaryOrder; j++)
		{
			if (i != j)
			{
				eltNo2 = orderList[j].classAfter;

				if (eltNo1 == eltNo2)
				{
					isInDegreeZero = 0;
					break;
				}
			}
		}

		if (isInDegreeZero == 1)
		{
			//set_insert(returnValue, eltNo1);
			set_insert(returnValue, i);
		}
	}

	return returnValue;
}

void ordering_findAllLinearOrderingFromSingleStart(mySetSet *finalResult, mySet *prefixSet, ordering *anOrdering, int startIndex)
{

	int noOfBinaryOrder;
	binaryOrder *orderList;

	int currIndex;
	int classAfter;
	int nextClassBefore;

	int i;

	int index;
	int startIndex_new;

	mySet *prefixSet_new;

	int isFound;

	mySet *oneResult;


	
	noOfBinaryOrder = anOrdering->noOfBinaryOrder;
	orderList = anOrdering->orderList;

	currIndex = startIndex;
	orderList[currIndex].isMarkBefore = 1;
	//while ()
	//{
	classAfter = orderList[currIndex].classAfter;

	// find classAfter
	isFound = 0;
	for (i = 0; i < noOfBinaryOrder; i++)
	{
		nextClassBefore = orderList[i].classBefore;

		if (classAfter == nextClassBefore)
		{
			//set_insert(candidateSet, i);
			index = i;

			startIndex_new = index;

			prefixSet_new = set_new();
			set_copy(prefixSet_new, prefixSet);
			set_insert(prefixSet_new, index);

			ordering_findAllLinearOrderingFromSingleStart(finalResult, prefixSet_new, anOrdering, startIndex_new);

			set_free(prefixSet_new);
			free(prefixSet_new);

			isFound = 1;
		}
	}

	if (isFound == 0)
	{
		oneResult = set_new();
		set_copy(oneResult, prefixSet);
		setset_insert(finalResult, &oneResult);
	}
}

/*
mySetSet *ordering_findAllLinearOrderingFromSingleStart(ordering *anOrdering, int startIndex)
{
	mySetSet *returnValue;
	ordering *cloneOrdering;

	mySet *aLinearOrdering;

	int i;

	returnValue = setset_new();

	cloneOrdering = ordering_clone(anOrdering);

	aLinearOrdering = ordering_findOneLinearOrderingFromSingleStart(cloneOrdering, startIndex);
	while (aLinearOrdering != NULL)
	{
		// insert
		set_insert(returnValue, aLinearOrdering);

		aLinearOrdering = ordering_findOneLinearOrderingFromSingleStart(cloneOrdering, startIndex);
	}

	// free
	ordering_free(cloneOrdering);
	free(cloneOrdering);

	return returnValue;
}
*/

mySetSet *ordering_generateAllLinearOrdering_Index(ordering *anOrdering)
{
	mySetSet *returnValue;

	mySet *startOrderingSet;

	int startElt;

	mySet *prefixSet;

	int i;

	startOrderingSet = ordering_findStart_LinearOrdering(anOrdering);

	returnValue = setset_new();

	for (i = 0; i < startOrderingSet->noOfElt; i++)
	{
		startElt = startOrderingSet->elt[i];

		prefixSet = set_new();
		set_insert(prefixSet, startElt);

		ordering_findAllLinearOrderingFromSingleStart(returnValue, prefixSet, anOrdering, startElt);

		set_free(prefixSet);
		free(prefixSet);
	}

	set_free(startOrderingSet);
	free(startOrderingSet);

	return returnValue;
}

mySetSet *ordering_transformIndex2ClassID(mySetSet *aSetSet, ordering *anOrdering)
{
	mySetSet *returnValue;

	int noOfElt;
	mySet **elt;

	mySet *aSet;

	int i, j;
	int *setElt;
	int noOfSetElt;

	int eltIndex;
	int tempNo;

	mySet *tempSet;

	binaryOrder *orderList;

	returnValue = setset_new();

	noOfElt = aSetSet->noOfElt;

	elt = aSetSet->elt;
	noOfElt = aSetSet->noOfElt;

	orderList = anOrdering->orderList;

	for (i = 0; i < noOfElt; i++)
	{
		aSet = elt[i];

		setElt = aSet->elt;
		noOfSetElt = aSet->noOfElt;

		
		if (noOfSetElt >= 1)
		{
			tempSet = set_new();

			for (j = 0; j < noOfSetElt; j++)
			{
				eltIndex = setElt[j];

				tempNo = orderList[eltIndex].classBefore;

				set_insert(tempSet, tempNo);
			}

			// special handle for the last entry
			tempNo = orderList[eltIndex].classAfter;
			set_insert(tempSet, tempNo);

			setset_insert(returnValue, &tempSet);
		}
	}

	return returnValue;
}

mySetSet *ordering_generateAllLinearOrdering(ordering *anOrdering)
{

	mySetSet *returnValue;
	mySetSet *tempIndex;
	
	tempIndex = ordering_generateAllLinearOrdering_Index(anOrdering);

	returnValue = ordering_transformIndex2ClassID(tempIndex, anOrdering);

	setset_free(tempIndex);
	free(tempIndex);

	return returnValue;
}

mainOrdering *mainOrdering_new()
{
	mainOrdering *returnValue;

	returnValue = (mainOrdering *) malloc(sizeof(mainOrdering));
	memset(returnValue, 0, sizeof(mainOrdering));

	return returnValue;
}

void mainOrdering_free(mainOrdering *aMainOrdering)
{
	int i;

	if (aMainOrdering->noOfElt > 0)
	{
		for (i = 0; i < aMainOrdering->noOfElt; i++)
		{
			ordering_free(aMainOrdering->elt[i]);
			free(aMainOrdering->elt[i]);
		}
		free(aMainOrdering->elt);
	}
}



void mainOrdering_insert(mainOrdering *aMainOrdering, ordering **anOrdering)
{
	int noOfElt;
	ordering **elt;

	//int i;

	noOfElt = aMainOrdering->noOfElt;
	elt = aMainOrdering->elt;

	if (noOfElt == 0)
	{
		aMainOrdering->elt = (ordering **) malloc(sizeof(ordering *));
		aMainOrdering->elt[0] = (*anOrdering);
		aMainOrdering->noOfElt++;
	}
	else
	{
		aMainOrdering->elt = (ordering **) realloc(aMainOrdering->elt, sizeof(ordering *)*(noOfElt+1));
		aMainOrdering->elt[noOfElt] = (*anOrdering);
		aMainOrdering->noOfElt++;
	}
}


// assume two els in list of aClassSEt
// does an ordering (in terms of a number of binary orders) contain the classSet where the
// classSet contain two elts for each dim. 
int mainOrdering_isContain_disqualify(int noOfNumAttr, mainOrdering *aMainOrdering, myClassSet *aClassSet)
{
	int returnValue;

	//mySet *tempSet;

	int i; //, j, k;

	int noOfElt;
	//int checkDimNo;

	ordering **elt;
	//ordering *eltOrdering;

	ordering *anOrdering;

	//int eltID;
	//int checkID;

	int isContain;

	int dimNo;
	int classID, classID2;

	mySet *aList;

	noOfElt = aMainOrdering->noOfElt;
	elt = aMainOrdering->elt;

	

	if (aClassSet->noOfElt > 0)
	{
		returnValue = 1;
		//checkDimNo = aClassSet->dimNo[0];
		for (i = 0; i < aClassSet->noOfElt; i++)
		{
			dimNo = aClassSet->dimNo[i];

			aList = aClassSet->list[i];
			classID = aList->elt[0];
			classID2 = aList->elt[1];

			anOrdering = aMainOrdering->elt[dimNo-noOfNumAttr];

			isContain = ordering_isContain(anOrdering, classID, classID2);
			if (isContain == 0)
			{
				returnValue = 0;
				break;
			}
		}
	}
	else
	{
		returnValue = 0;
	}

	return returnValue;
}

//allLinearElt = ordering_generateAllLinearOrdering(partialOrder);
/*
mySetSet *ordering_generateAllLinearOrdering_all(int noOfNumAttr, mainOrdering *aMainOrdering)
{
	mySetSet *returnValue;

	int i;
	int noOfElt;

	ordering *partialOrder;
	ordering **elt;

	int *index;

	mySetSet **allLinearEltList;

	int tempNo;

	returnValue = setset_new();

	noOfElt = aMainOrdering->noOfElt;
	elt = aMainOrdering->elt;

	allLinearEltList = (mySetSet **) malloc(sizeof(mySetSet *)*noOfElt);
	index = (int *) malloc(sizeof(int)*noOfElt);
	memset(index, 0, sizeof(int)*noOfElt);

	for (i = 0; i < noOfElt; i++)
	{
		partialOrder = elt[i];
		allLinearEltList[i] = ordering_generateAllLinearOrdering(partialOrder);
	}

	// create an Ordering
	if (noOfElt > 0)
	{
		while (1)
		{
			anOrderSet = orderSet_new();
			for (i = 0; i < noOfElt; i++)
			{
				dimNo = noOfNumAttr+i;
				
				tempIndex = index[i];
				anOrdering = allLinearEltList[i]->elt[tempindex];
				orderSet_insert(anOrderSet, dimNo, anOrdering);
				
				//index[i] = ((index[i]+1)%allLinearEltList[i]->noOfElt);
			}
			orderSet_free(anOrderSet);
			free(anOrderSet);

			// move index
			count = 1;
			index[noOfElt-count]++;
			while ((noOfElt-count >= 0) &&  (index[noOfElt-count] == allLinearEltList[noOfElt-count]->noOfElt))
			{
				index[noOfElt-count] = 0;

				count++;
				if (noOfElt-count >= 0)
				{
					index[noOfElt-count]++;
				}
				else
				{
					// do nothing
				}
			}

			if (noOfElt-count < 0)
			{
				break;
			}
		}
	}


	// free
	for (i = 0; i < noOfElt; i++)
	{
		setset_free(allLinerEltList[i]);
		free(allLinearEltList[i]);
	}
	free(allLinearEltList);
	
	free(index);

	return returnValue;
}
*/


/**
 * It takes in a full order query(anOrderSet) and use the
 * information to produce a complete full binary orderings
 * implied in the full order query.
 * @param anOrderSet A full order query
 * @return Complete full binary orderings
 */
mainOrdering *mainOrdering_transformOrderSet2MainOrdering(myOrderSet *anOrderSet)
{
	mainOrdering *returnValue;

	ordering *anOrdering;

	int classBefore, classAfter;

	mySet *anOrderList;

	int i, j, k; 

	returnValue = mainOrdering_new();

	for (i = 0; i < anOrderSet->noOfElt; i++)
	{
		anOrderList = anOrderSet->orderList[i];

		anOrdering = ordering_new();

		for (j = 0; j < anOrderList->noOfElt; j++)
		{
			classBefore = anOrderList->elt[j];
			for (k = j+1; k < anOrderList->noOfElt; k++)
			{
				classAfter = anOrderList->elt[k];
				ordering_insertBinaryOrder2Ordering(anOrdering, classBefore, classAfter);
			}
		}

		mainOrdering_insert(returnValue, &anOrdering);
	}
	
	return returnValue;
}

/**
 * It takes in a partial order preference(R) and use
 * the information to produce a complete full binary
 * orderings implied inside the partial order preferences 
 *
 * @param noOfClass Need to know how many classes in each
 *                categorical dimension
 * @param R Partial preference ordering
 * @return Complete full binary orderings
 * @author Terry & Sing
 * @since 28 Feb 2007
 */
mainOrdering* mainOrdering_transformPartialOrder2MainOrdering(int *noOfClass, mySetSet *R)
{
	int i, j, k, l; 
	int classBefore, classAfter;
	mainOrdering *returnValue;
	ordering *anOrdering;
	mySet *anOrderList;

	returnValue = mainOrdering_new();

	//For each catagorical dimensions
	for (i = 0; i < R->noOfElt; i++)
	{
		anOrderList = R->elt[i];
		anOrdering = ordering_new();

		//For each preferred class in ith categorical dimension
		for (j = 0; j < R->elt[i]->noOfElt; j++)
		{
			classBefore = R->elt[i]->elt[j];
			//For each classes that is dominated by jth preferred class
			for (k = j+1; k < R->elt[i]->noOfElt; k++)
			{
				classAfter = R->elt[i]->elt[k];
				ordering_insertBinaryOrder2Ordering(anOrdering, classBefore, classAfter);
			}
			//Need to include also the classes that is not
			//mentioned in the partial query. These classes are
			//dominated by all mentioned classes
			for (k=0; k<noOfClass[i]; k++)
			{
				int isNotPreferedClass = 1;
				for (l=0; l < R->elt[i]->noOfElt; l++)
				{
					if (k==R->elt[i]->elt[l])
					{
						isNotPreferedClass = 0;
						break;
					}
				}
				if (isNotPreferedClass)
				{
					classAfter = k;
					ordering_insertBinaryOrder2Ordering(anOrdering, classBefore, classAfter);
				}
			}
		}
		mainOrdering_insert(returnValue, &anOrdering);
	}
	return returnValue;
}

/**
 * Print all the binary orderings in all dimensions of aMainOrdering
 * @param filePtr File handle
 * @param aMainOrdering Contains all binary orders to be printed
 * @author Terry & Sing
 * @since 28 Feb 2007
 */
void mainOrdering_printMainOrdering(FILE *filePtr, mainOrdering *aMainOrdering)
{
	int i;
	puts("");
	for (i=0; i<aMainOrdering->noOfElt; i++)
	{
		printf("Binary Order in Dim: %d\n", i);
		puts("--------------------------");
		ordering_printOrdering(filePtr, aMainOrdering->elt[i]);
		puts("");
	}
}
