
#include "queue.h"


myQueue *queue_new()
{
	myQueue *returnValue;

	returnValue = (myQueue *) malloc(sizeof(myQueue));
	memset(returnValue, 0, sizeof(myQueue));

	return returnValue;
}

void queue_free(myQueue *aQueue)
{
	if (aQueue->noOfElt > 0)
	{
		free(aQueue->elt);
	}
}

void queue_enqueue(myQueue *aQueue, STNode **no)
{
	int noOfElt;

	noOfElt = aQueue->noOfElt;

	if (noOfElt == 0)
	{
		aQueue->elt = (STNode **) malloc(sizeof(STNode *));
	}
	else
	{
		aQueue->elt = (STNode **) realloc(aQueue->elt, sizeof(STNode *)*(noOfElt+1));
	}
	aQueue->elt[noOfElt] = (*no);

	aQueue->noOfElt++;
}

// NULL: if the no. of elt = 0
STNode *queue_dequeue(myQueue *aQueue)
{
	STNode * returnValue;

	int noOfElt;
	STNode **oldElt;

	noOfElt = aQueue->noOfElt;

	if (noOfElt == 0)
	{
		returnValue = NULL;
	}
	else
	{
		returnValue = aQueue->elt[0];

		oldElt = aQueue->elt;
		if (noOfElt == 1)
		{
			// do nothing
		}
		else
		{
			aQueue->elt = (STNode **) malloc(sizeof(STNode *)*(noOfElt-1));
			memcpy(aQueue->elt, &(oldElt[1]), sizeof(STNode *)*(noOfElt-1));
		}

		free(oldElt);
		aQueue->noOfElt--;
	}

	return returnValue;
}
