
#include "sfs.h"

int **sfs_determineTemplateRanking(config *aConfig)
{
	int **returnValue;
	int i, j, k;

	ordering **aOrdering;
	ordering *templOne;

	binaryOrder *orderList;
	int noOfBinaryOrder;

	int classBefore;
	int classAfter;

	int noOfLeft;
	int *leftList;

	int *noOfDominate;

	int isExist;

	int *index;
	int aIndex, aElt;

	returnValue = (int **) malloc(sizeof(int *)*aConfig->noOfCat);

	for (i = 0; i < aConfig->noOfCat; i++)
	{
		returnValue[i] = (int *) malloc(sizeof(int)*aConfig->noOfClass[i]);
		//memset(returnValue[i], 0, sizeof(int)*aConfig->noOfClass[i]);
		for (j = 0; j < aConfig->noOfClass[i]; j++)
		{
			//returnValue[i][j] = aConfig->noOfClass[i]-1;
			returnValue[i][j] = aConfig->noOfClass[i];
		}
	}

	aOrdering = aConfig->templ;

	for (i = 0; i < aConfig->noOfCat; i++)
	{
		// left
		leftList = (int *) malloc(sizeof(int)*aConfig->noOfClass[i]);
		memset(leftList, 0, sizeof(int)*aConfig->noOfClass[i]);

		noOfLeft = 0;

		// find leftList
		templOne = aOrdering[i];

		noOfBinaryOrder = templOne->noOfBinaryOrder;
		orderList = templOne->orderList;

		for (j = 0; j < noOfBinaryOrder; j++)
		{
			classBefore = orderList[j].classBefore;
			classAfter = orderList[j].classAfter;

			isExist = 0;
			for (k = 0; k < noOfLeft; k++)
			{
				if (leftList[k] == classBefore)
				{
					isExist = 1;
					break;
				}
			}

			if (isExist == 0)
			{
				leftList[noOfLeft] = classBefore;
				noOfLeft++;
			}
		}

		// finish find leftList
		// determine the ranking of each elt in leftList
		if (noOfLeft > 0)
		{
			// calculate noOfDominate
			noOfDominate = (int *) malloc(sizeof(int)*noOfLeft);
			memset(noOfDominate, 0, sizeof(int)*noOfLeft);

			for (j = 0; j < noOfBinaryOrder; j++)
			{
				classBefore = orderList[j].classBefore;
				classAfter = orderList[j].classAfter;

				for (k = 0; k < noOfLeft; k++)
				{
					if (leftList[k] == classBefore)
					{
						noOfDominate[k]++;
						break;
					}
				}

			}

			index = (int *) malloc(sizeof(int)*noOfLeft);
			for (j = 0; j < noOfLeft; j++)
			{
				index[j] = j;
			}

			// determine the ranking
			quicksort_i(index, noOfDominate, 0, noOfLeft-1);

			for (j = 0; j < noOfLeft; j++)
			{
				aIndex = index[j];
				aElt = leftList[aIndex];

				returnValue[i][aElt] = j;
			}
			

			free(index);
			
			free(noOfDominate);
		}
		else
		{
			// determine the ranking
			// no need to do anything
		}

		free(leftList);
	}

	return returnValue;
}

int sfs_getValue(int **ranking, int noOfNumAttr, int noOfCatAttr, record *aRecord)
{
	int returnValue;
	int classValue;

	int j;
	int aRank;

	returnValue = 0;
	// numeric attr.
	for (j = 0; j < noOfNumAttr; j++)
	{
		returnValue += aRecord->content[j];
	}

	// cat. attr.
	for (j = 0; j < noOfCatAttr; j++)
	{
		classValue = aRecord->content[noOfNumAttr+j];
		aRank = ranking[j][classValue]; 
		returnValue += aRank;
	}

	return returnValue;
}

int *sfs_presorting(config *aConfig, int **ranking, int *skylineSet, int noOfSkyline)
{
	int *returnValue;

	int i;
	int aElt;

	record *data;
	record *aRecord;

	int noOfNumAttr;

	int *value;
	int *index;
	int *old_index;

	int aIndex;


	noOfNumAttr = aConfig->noOfDim - aConfig->noOfCat;

	data = aConfig->data;

	value = (int *) malloc(sizeof(int)*noOfSkyline);
	memset(value, 0, sizeof(int)*noOfSkyline);

	// find value of a function
	for (i = 0; i < noOfSkyline; i++)
	{
		aElt = skylineSet[i];

		aRecord = &(data[aElt]);

		value[i] = sfs_getValue(ranking, noOfNumAttr, aConfig->noOfCat, aRecord);
	}

	// sorting
	old_index = (int *) malloc(sizeof(int)*noOfSkyline);
	for (i = 0; i < noOfSkyline; i++)
	{
		old_index[i] = i;
	}
	quicksort_i(old_index, value, 0, noOfSkyline-1);
	// reverse
	index = (int *) malloc(sizeof(int)*noOfSkyline);
	for (i = 0; i < noOfSkyline; i++)
	{
		index[i] = old_index[noOfSkyline-1-i];
	}

	returnValue = (int *) malloc(sizeof(int)*noOfSkyline);
	memset(returnValue, 0, sizeof(int)*noOfSkyline);
	for (i = 0; i < noOfSkyline; i++)
	{
		aIndex = index[i];
		aElt = skylineSet[aIndex];

		returnValue[i] = aElt;
	}

	free(old_index);
	free(index);
	free(value);

	return returnValue;
}



mySet *sfs_preprocess(config *aConfig, mySet *remainD, mySet *globalSkyline, sfs_stat *aStat)
{
	mySet *returnValue;
	int noOfRemainD;
	int *listRemainD;

	int noOfGlobal;
	int *listGlobal;

	int noOfSkyline;
	int *skylineSet;
	int *value;

	int **ranking;
	int *presortOrder;

	int i;


	noOfGlobal = globalSkyline->noOfElt;
	listGlobal = globalSkyline->elt;

	noOfRemainD = remainD->noOfElt;
	listRemainD = remainD->elt;

	//
	noOfSkyline = noOfRemainD + noOfGlobal;
	skylineSet = (int *) malloc(sizeof(int)*noOfSkyline);
	value = (int *) malloc(sizeof(int)*noOfSkyline);

	memcpy(skylineSet, listGlobal, sizeof(int)*noOfGlobal);
	memcpy(&(skylineSet[noOfGlobal]), listRemainD, sizeof(int)*noOfRemainD);

	// stat
	aStat->noOfTemplateSkyline = noOfSkyline;
	
	// determine the template ranking
	printf("   Determining the template ranking...\n");
	ranking = sfs_determineTemplateRanking(aConfig);

	// presorting
	printf("   Pre-sorting...\n");
	presortOrder = sfs_presorting(aConfig, ranking, skylineSet, noOfSkyline);


	// free
	for (i = 0; i < aConfig->noOfCat; i++)
	{
		free(ranking[i]);
	}
	free(ranking);

	returnValue = set_new();
	returnValue->noOfElt = noOfSkyline;
	returnValue->elt = presortOrder;

	return returnValue;
}

int **sfs_determineQueryRanking(config *aConfig)
{
	int **returnValue;

	mySetSet *RR;

	mySet *eltList;

	int aClassValue;

	int i, j;

	returnValue = (int **) malloc(sizeof(int *)*aConfig->noOfCat);

	for (i = 0; i < aConfig->noOfCat; i++)
	{
		returnValue[i] = (int *) malloc(sizeof(int)*aConfig->noOfClass[i]);
		//memset(returnValue[i], 0, sizeof(int)*aConfig->noOfClass[i]);
		for (j = 0; j < aConfig->noOfClass[i]; j++)
		{
			//returnValue[i][j] = aConfig->noOfClass[i]-1;
			returnValue[i][j] = aConfig->noOfClass[i];
		}
	}

	RR = config_readPreference(aConfig);

	// get the rank
	for (i = 0; i < aConfig->noOfCat; i++)
	{
		eltList = RR->elt[i];
		
		for (j = 0; j < eltList->noOfElt; j++)
		{
			aClassValue = eltList->elt[j];
			returnValue[i][aClassValue] = j;
		}

		set_free(eltList);
		free(eltList);
	}
	free(RR);

	return returnValue;
}

// flag for remove
int *sfs_findRemoval(config *aConfig, mySet *presortOrder)
{
	int *returnValue;
	int noOfElt;
	int *elt;

	int i, j, k;

	int aElt;

	record *data;

	mySetSet *RR;

	mySet *eltList;

	int isExist;

	int aClassValue;
	int noOfNumAttr;

	noOfElt = presortOrder->noOfElt;
	elt = presortOrder->elt;

	data = aConfig->data;

	noOfNumAttr = aConfig->noOfDim - aConfig->noOfCat;

	RR = config_readPreference(aConfig);

	returnValue = (int *) malloc(sizeof(int)*noOfElt);
	memset(returnValue, 0, sizeof(int)*noOfElt);

	for (i = 0; i < noOfElt; i++)
	{
		aElt = elt[i];

		// check isExist
		isExist = 0;
		for (j = 0; j < aConfig->noOfCat; j++)
		{
			aClassValue = data[aElt].content[noOfNumAttr + j];

			eltList = RR->elt[j];

			for (k = 0; k < eltList->noOfElt; k++)
			{
				if (eltList->elt[k] == aClassValue)
				{
					isExist = 1;
					break;
				}
			}

			if (isExist == 1)
			{
				break;
			}
		}

		if (isExist == 1)
		{
			returnValue[i] = 1;
		}
	}

	return returnValue;
}

void sfs_splitNonRemovalAndRemoval(config *aConfig, mySet *presortOrder, int *isRemove, mySet *nonRemovalSet, mySet *removalSet)
{
	int noOfElt;
	int *elt;
	int aElt;

	int i;

	int noOfRemove, noOfNonRemove;

	int countRemove, countNonRemove;

	noOfElt = presortOrder->noOfElt;
	elt = presortOrder->elt;

	noOfRemove = 0;
	for (i = 0; i < noOfElt; i++)
	{
		if (isRemove[i] == 1)
		{
			noOfRemove++;
		}
	}

	// removalSet
	removalSet->noOfElt = noOfRemove;
	removalSet->elt = (int *) malloc(sizeof(int)*noOfRemove);
	memset(removalSet->elt, 0, sizeof(int)*noOfRemove);

	// nonRemovalSet
	noOfNonRemove = noOfElt - noOfRemove;

	nonRemovalSet->noOfElt = noOfNonRemove;
	nonRemovalSet->elt = (int *) malloc(sizeof(int)*noOfNonRemove);
	memset(nonRemovalSet->elt, 0, sizeof(int)*noOfNonRemove);

	//
	countRemove = 0;
	countNonRemove = 0;

	for (i = 0; i < noOfElt; i++)
	{
		aElt = elt[i];

		if (isRemove[i] == 1)
		{
			removalSet->elt[countRemove] = aElt;
			countRemove++;
		}
		else
		{
			nonRemovalSet->elt[countNonRemove] = aElt;
			countNonRemove++;
		}
	}
}


mySet *sfs_mergeNonRemovalAndRemoval(config *aConfig, mySet *nonRemovalSet, mySet *removalSet, int **ranking)
{
	mySet *returnValue;

	int noOfRemove;
	int *removeList;

	int noOfNonRemove;
	int *nonRemoveList;

	int indexRemove, indexNonRemove, indexMerge;

	int i;

	int noOfMerge;
	int *mergeList;

	int *valueRemove;
	int *valueNonRemove;

	int aElt;

	record *data;

	record *aRecord;

	int noOfNumAttr;

	int aEltRemove, aEltNonRemove;

	int aValueRemove, aValueNonRemove;

	data = aConfig->data;
	noOfNumAttr = aConfig->noOfDim - aConfig->noOfCat;

	noOfRemove = removalSet->noOfElt;
	removeList = removalSet->elt;

	noOfNonRemove = nonRemovalSet->noOfElt;
	nonRemoveList = nonRemovalSet->elt;

	noOfMerge = noOfRemove + noOfNonRemove;
	mergeList = (int *) malloc(sizeof(int)*noOfMerge);
	memset(mergeList, 0, sizeof(int)*noOfMerge);

	returnValue = set_new();
	returnValue->noOfElt = noOfMerge;
	returnValue->elt = mergeList;

	


	// merging
	indexRemove = 0;
	indexNonRemove = 0;

	indexMerge = 0;

	if (noOfRemove > 0)
	{
		valueRemove = (int *) malloc(sizeof(int)*noOfRemove);

		// getValue for valueRemove
		for (i = 0; i < noOfRemove; i++)
		{
			aElt = removeList[i];

			aRecord = &(data[aElt]);

			valueRemove[i] = sfs_getValue(ranking, noOfNumAttr, aConfig->noOfCat, aRecord);
		}
	}

	if (noOfNonRemove > 0)
	{
		valueNonRemove = (int *) malloc(sizeof(int)*noOfNonRemove);

		// getValue for valueNonRemove
		for (i = 0; i < noOfNonRemove; i++)
		{
			aElt = nonRemoveList[i];

			aRecord = &(data[aElt]);

			valueNonRemove[i] = sfs_getValue(ranking, noOfNumAttr, aConfig->noOfCat, aRecord);
		}
	}

	if (noOfRemove <= 0)
	{
		// that is, we can create mergeList (from nonRemovalSet)
		memcpy(mergeList, nonRemovalSet, sizeof(int)*noOfNonRemove);
	}
	else
	{
		if (noOfNonRemove <= 0)
		{
			// that is, we can create mergeList (from removalSet)
			memcpy(mergeList, removalSet, sizeof(int)*noOfRemove);
		}
		else
		{
			// that is, both noOfRemove > 0 and noOfNonRemove > 0
			// NOTE: valueRemove is sorted in ascending order
			//       valueNonRemove is sorted in ascending order

			// common part
			while ((indexRemove < noOfRemove) && (indexNonRemove < noOfNonRemove))
			{
				aEltRemove = removeList[indexRemove];
				aEltNonRemove = nonRemoveList[indexNonRemove];

				aValueRemove = valueRemove[indexRemove];
				aValueNonRemove = valueNonRemove[indexNonRemove];

				if (aValueRemove < aValueNonRemove)
				{
					mergeList[indexMerge] = aEltRemove;	
					indexRemove++;
				}
				else
				{
					mergeList[indexMerge] = aEltNonRemove;	
					indexNonRemove++;
				}
				indexMerge++;
			}

			// one of them has been exhausted
			if (indexRemove >= noOfRemove)
			{
				while (indexNonRemove < noOfNonRemove)
				{
					aEltNonRemove = nonRemoveList[indexNonRemove];

					mergeList[indexMerge] = aEltNonRemove;
					indexNonRemove++;

					indexMerge++;
				}
			}
			else
			{
				// that is, indexNonRemove >= noOfNonRemove
				while (indexRemove < noOfRemove)
				{
					aEltRemove = removeList[indexRemove];

					mergeList[indexMerge] = aEltRemove;
					indexRemove++;

					indexMerge++;
				}
			}
		}
	}


	if (noOfNonRemove > 0)
	{
		free(valueNonRemove);
	}
	if (noOfRemove > 0)
	{
		free(valueRemove);
	}

	return returnValue;
}

int sfs_isDominateEltElt(config *aConfig, int **ranking, int elt1, int elt2)
{
	int returnValue;

	int i;

	record *record1;
	record *record2;

	int noOfNumAttr;

	record *data;

	int value1, value2;
	int rank1, rank2;

	noOfNumAttr = aConfig->noOfDim - aConfig->noOfCat;

	data = aConfig->data;

	record1 = &(data[elt1]);
	record2 = &(data[elt2]);

	returnValue = 1;

	// numeric attr
	for (i = 0; i < noOfNumAttr; i++)
	{
		value1 = record1->content[i];
		value2 = record2->content[i];

		if (value1 > value2)
		{
			returnValue = 0;
			break;
		}
	}

	// cat. attr
	if (returnValue == 1)
	{
		for (i = 0; i < aConfig->noOfCat; i++)
		{
			value1 = record1->content[noOfNumAttr + i];
			value2 = record2->content[noOfNumAttr + i];

			rank1 = ranking[i][value1];
			rank2 = ranking[i][value2];

			if ((rank1 == aConfig->noOfClass[i]) && (rank2 == aConfig->noOfClass[i]))
			{
				if (value1 != value2)
				{
					returnValue = 0;
					break;
				}
			}

			if (rank1 > rank2)
			{
				returnValue = 0;
				break;
			}
		}
	}

	return returnValue;
}


int sfs_isDominateSetElt(config *aConfig, int **ranking, mySet *aSet, int aElt)
{
	int returnValue;

	int i;

	int noOfElt;
	int *eltList;

	int isDominate;

	noOfElt = aSet->noOfElt;
	eltList = aSet->elt;

	returnValue = 0;
	for (i = 0; i < noOfElt; i++)
	{
		isDominate = sfs_isDominateEltElt(aConfig, ranking, eltList[i], aElt);
		if (isDominate == 1)
		{
			returnValue = 1;
			break;
		}
	}
	

	return returnValue;
}

// assume sortSet is sorted in ascending order
mySet *sfs_findSkylineFromSortSet(config *aConfig, int **ranking, mySet *sortSet)
{
	mySet *returnValue;

	int i;
	int aElt;

	int noOfElt;
	int *eltList;

	int isDominate;

	FILE *filePtr;
	char *filename = "progress.txt";

	filePtr = (FILE *) fopen(filename, "w");
	if (filePtr == NULL)
	{
		printf("File %s cannot be opened!\n", filename);
		exit(0);
	}

	returnValue = set_new();

	noOfElt = sortSet->noOfElt;
	eltList = sortSet->elt;

fprintf(filePtr, "%d\n", noOfElt);
	for (i = 0; i < noOfElt; i++)
	{
		aElt = eltList[i];
if (aElt == 27)
{
	printf("");
}
		isDominate = sfs_isDominateSetElt(aConfig, ranking, returnValue, aElt);

fprintf(filePtr, "%d\n", 1-isDominate);

		if (isDominate == 0)
		{
			set_insert(returnValue, aElt);
		}
	}
fprintf(filePtr, "%d\n", returnValue->noOfElt);
	fclose(filePtr);

	return returnValue;
}

mySet *sfs_query(config *aConfig, mySet *presortOrder, sfs_stat *aStat)
{
	mySet *returnValue;

	int **ranking;

	int *isRemove;

	int *tempList;

	mySet *nonRemovalSet;
	mySet *removalSet;
	mySet *mergeSet;

	// get the ranking
	printf("   Determining the query ranking...\n");
	ranking = sfs_determineQueryRanking(aConfig);

	// find isFlag for removal
	printf("   Finding removal...\n");
	isRemove = sfs_findRemoval(aConfig, presortOrder);

	// split into non-removal and removal
	printf("   Splitting...\n");
	nonRemovalSet = set_new();
	removalSet = set_new();
	sfs_splitNonRemovalAndRemoval(aConfig, presortOrder, isRemove, nonRemovalSet, removalSet);

	// stat
	aStat->noOfAffect = removalSet->noOfElt;
	aStat->noOfNonAffect = aStat->noOfTemplateSkyline - aStat->noOfAffect;

	// sort removalSet
	printf("   Sorting removalSet...\n");
	tempList = sfs_presorting(aConfig, ranking, removalSet->elt, removalSet->noOfElt);
	free(removalSet->elt);
	removalSet->elt = tempList;

	// note that nonRemovalSet has already been sorted in ascending order

	// merge removalSet and nonRemovalSet
	printf("   Merging...\n");
	mergeSet = sfs_mergeNonRemovalAndRemoval(aConfig, nonRemovalSet, removalSet, ranking);

	// find skyline from sorted set
	printf("   Finding skyline...\n");
	returnValue = sfs_findSkylineFromSortSet(aConfig, ranking, mergeSet);

	return returnValue;
}


mySet *sfsBaseline_query(config *aConfig, mySet *presortOrder, sfs_stat *aStat)
{
	mySet *returnValue;

	int **ranking;

	int *tempList;

	mySet *cloneSet;

	// get the ranking
	printf("   Determining the query ranking...\n");
	ranking = sfs_determineQueryRanking(aConfig);

	// cloning
	cloneSet = set_new();
	cloneSet->elt = (int *) malloc(sizeof(int)*presortOrder->noOfElt);
	memcpy(cloneSet->elt, presortOrder->elt, sizeof(int)*presortOrder->noOfElt);
	cloneSet->noOfElt = presortOrder->noOfElt;

	// sort the presortOrder
	printf("   Sorting the presortOrder accdoring to the preference...\n");
	tempList = sfs_presorting(aConfig, ranking, cloneSet->elt, cloneSet->noOfElt);
	free(cloneSet->elt);
	cloneSet->elt = tempList;

	// find skyline from sorted set
	printf("   Finding skyline...\n");
	returnValue = sfs_findSkylineFromSortSet(aConfig, ranking, cloneSet);

	// free
	set_free(cloneSet);
	free(cloneSet);

	return returnValue;
}



mySet *sfsNaive_query(config *aConfig, mySet *presortOrder, sfs_stat *aStat)
{
	mySet *returnValue;

	int **ranking;

	int *tempList;

	mySet *cloneSet;

	// get the ranking
	printf("   Determining the query ranking...\n");
	ranking = sfs_determineQueryRanking(aConfig);

	// cloning
	cloneSet = set_new();
	cloneSet->elt = (int *) malloc(sizeof(int)*presortOrder->noOfElt);
	memcpy(cloneSet->elt, presortOrder->elt, sizeof(int)*presortOrder->noOfElt);
	cloneSet->noOfElt = presortOrder->noOfElt;

	// sort the presortOrder
	printf("   Sorting the presortOrder accdoring to the preference...\n");
	tempList = sfs_presorting(aConfig, ranking, cloneSet->elt, cloneSet->noOfElt);
	free(cloneSet->elt);
	cloneSet->elt = tempList;

	// find skyline from sorted set
	printf("   Finding skyline...\n");
	returnValue = sfs_findSkylineFromSortSet(aConfig, ranking, cloneSet);

	// free
	set_free(cloneSet);
	free(cloneSet);

	return returnValue;
}


void sfs_main(config *aConfig, mySet *remainD, mySet *globalSkyline, FILE *debugFilePtr, FILE *timeFilePtr)
{
	int i, j;

	int *index;
	int *elt;
	
	mySet *presortOrder;
	mySet *querySkylineSet;

	sfs_stat aStat;


#ifndef WIN32
	struct rusage preprocess_start;
	struct rusage preprocess_end;
	struct rusage query_end;
	float qc_preprocess_time_u;
	float qc_preprocess_time_s;
	float qc_query_time_u;
	float qc_query_time_s;
#endif


#ifndef WIN32
	getrusage(RUSAGE_SELF,&preprocess_start);
#endif

	//**** Preprocessing
	printf("Preprocessing...\n");
	presortOrder = sfs_preprocess(aConfig, remainD, globalSkyline, &aStat);

#ifndef WIN32
	getrusage(RUSAGE_SELF,&preprocess_end);
#endif

	//**** Query
	printf("Query...\n");
	for (i = 0; i < aConfig->noOfFullOrderQuery; i++)
	{
		querySkylineSet = sfs_query(aConfig, presortOrder, &aStat);

		if (querySkylineSet->noOfElt > 0)
		{
			index = (int *) malloc(sizeof(int)*querySkylineSet->noOfElt);
			elt = (int *) malloc(sizeof(int)*querySkylineSet->noOfElt);
			memcpy(elt, querySkylineSet->elt, sizeof(int)*querySkylineSet->noOfElt);
			for (j = 0; j < querySkylineSet->noOfElt; j++)
			{
				index[j] = j;
			}
			quicksort_i(index, elt, 0, querySkylineSet->noOfElt-1);
			for (j = 0; j < querySkylineSet->noOfElt; j++)
			{
				querySkylineSet->elt[j] = elt[querySkylineSet->noOfElt-1-j];
			}
			free(index);
			free(elt);
		}

		printf("Skyline (%d): ", querySkylineSet->noOfElt);
		set_print(stdout, querySkylineSet);
		printf("\n");

		//stat
		aStat.noOfQuerySkyline = querySkylineSet->noOfElt;

		set_free(querySkylineSet);
		free(querySkylineSet);
	}

#ifndef WIN32
	getrusage(RUSAGE_SELF,&query_end);
#endif

	fprintf(debugFilePtr, "%d\n", aStat.noOfTemplateSkyline);
	fprintf(debugFilePtr, "%d\n", aStat.noOfQuerySkyline);
	fprintf(debugFilePtr, "%d\n", aStat.noOfAffect);
	fprintf(debugFilePtr, "%d\n", aStat.noOfNonAffect);

#ifndef WIN32
	calculateExecutionTime(&preprocess_start, &preprocess_end,
			&qc_preprocess_time_u, &qc_preprocess_time_s);
	calculateExecutionTime(&preprocess_end, &query_end,
			&qc_query_time_u, &qc_query_time_s);
	qc_query_time_u /= aConfig->noOfFullOrderQuery;
	qc_query_time_s /= aConfig->noOfFullOrderQuery;

	fprintf(timeFilePtr, "%.10f\t%.10f\n", qc_preprocess_time_u,
			qc_preprocess_time_s);
	fprintf(timeFilePtr, "%.10f\t%.10f\n", qc_query_time_u,
			qc_query_time_s);

	printf("building time: %.10f\t%.10f\n", qc_preprocess_time_u,
			qc_preprocess_time_s);
	printf("querying time: %.10f\t%.10f\n", qc_query_time_u,
			qc_query_time_s);
#endif
}



void sfsBaseline_main(config *aConfig, mySet *remainD, mySet *globalSkyline, FILE *debugFilePtr, FILE *timeFilePtr)
{
	int i, j;

	int *index;
	int *elt;
	
	mySet *presortOrder;
	mySet *querySkylineSet;

	sfs_stat aStat;


#ifndef WIN32
	struct rusage preprocess_start;
	struct rusage preprocess_end;
	struct rusage query_end;
	float qc_preprocess_time_u;
	float qc_preprocess_time_s;
	float qc_query_time_u;
	float qc_query_time_s;
#endif


#ifndef WIN32
	getrusage(RUSAGE_SELF,&preprocess_start);
#endif

	//**** Preprocessing
	printf("Preprocessing...\n");
	presortOrder = sfs_preprocess(aConfig, remainD, globalSkyline, &aStat);

#ifndef WIN32
	getrusage(RUSAGE_SELF,&preprocess_end);
#endif

	//**** Query
	printf("Query...\n");
	for (i = 0; i < aConfig->noOfFullOrderQuery; i++)
	{
		querySkylineSet = sfsBaseline_query(aConfig, presortOrder, &aStat);

		if (querySkylineSet->noOfElt > 0)
		{
			index = (int *) malloc(sizeof(int)*querySkylineSet->noOfElt);
			elt = (int *) malloc(sizeof(int)*querySkylineSet->noOfElt);
			memcpy(elt, querySkylineSet->elt, sizeof(int)*querySkylineSet->noOfElt);
			for (j = 0; j < querySkylineSet->noOfElt; j++)
			{
				index[j] = j;
			}
			quicksort_i(index, elt, 0, querySkylineSet->noOfElt-1);
			for (j = 0; j < querySkylineSet->noOfElt; j++)
			{
				querySkylineSet->elt[j] = elt[querySkylineSet->noOfElt-1-j];
			}
			free(index);
			free(elt);
		}

		printf("Skyline (%d): ", querySkylineSet->noOfElt);
		set_print(stdout, querySkylineSet);
		printf("\n");

		//stat
		aStat.noOfQuerySkyline = querySkylineSet->noOfElt;

		set_free(querySkylineSet);
		free(querySkylineSet);
	}

#ifndef WIN32
	getrusage(RUSAGE_SELF,&query_end);
#endif

	fprintf(debugFilePtr, "%d\n", aStat.noOfTemplateSkyline);
	fprintf(debugFilePtr, "%d\n", aStat.noOfQuerySkyline);
	fprintf(debugFilePtr, "%d\n", aStat.noOfAffect);
	fprintf(debugFilePtr, "%d\n", aStat.noOfNonAffect);

#ifndef WIN32
	calculateExecutionTime(&preprocess_start, &preprocess_end,
			&qc_preprocess_time_u, &qc_preprocess_time_s);
	calculateExecutionTime(&preprocess_end, &query_end,
			&qc_query_time_u, &qc_query_time_s);
	qc_query_time_u /= aConfig->noOfFullOrderQuery;
	qc_query_time_s /= aConfig->noOfFullOrderQuery;

	fprintf(timeFilePtr, "%.10f\t%.10f\n", qc_preprocess_time_u,
			qc_preprocess_time_s);
	fprintf(timeFilePtr, "%.10f\t%.10f\n", qc_query_time_u,
			qc_query_time_s);

	printf("building time: %.10f\t%.10f\n", qc_preprocess_time_u,
			qc_preprocess_time_s);
	printf("querying time: %.10f\t%.10f\n", qc_query_time_u,
			qc_query_time_s);
#endif
}



void sfsNaive_main(config *aConfig, mySet *remainD, mySet *globalSkyline, FILE *debugFilePtr, FILE *timeFilePtr)
{
	int i, j;

	int *index;
	int *elt;
	
	mySet *presortOrder;
	mySet *querySkylineSet;

	sfs_stat aStat;


#ifndef WIN32
	struct rusage preprocess_start;
	struct rusage preprocess_end;
	struct rusage query_end;
	float qc_preprocess_time_u;
	float qc_preprocess_time_s;
	float qc_query_time_u;
	float qc_query_time_s;
#endif


#ifndef WIN32
	getrusage(RUSAGE_SELF,&preprocess_start);
#endif

	//**** Preprocessing
	printf("Preprocessing...\n");
	presortOrder = set_new();
	for (i = 0; i < aConfig->noOfData; i++)
	{
		set_insert(presortOrder, i);
	}

#ifndef WIN32
	getrusage(RUSAGE_SELF,&preprocess_end);
#endif

	//**** Query
	printf("Query...\n");
	for (i = 0; i < aConfig->noOfFullOrderQuery; i++)
	{
		querySkylineSet = sfsNaive_query(aConfig, presortOrder, &aStat);

		if (querySkylineSet->noOfElt > 0)
		{
			index = (int *) malloc(sizeof(int)*querySkylineSet->noOfElt);
			elt = (int *) malloc(sizeof(int)*querySkylineSet->noOfElt);
			memcpy(elt, querySkylineSet->elt, sizeof(int)*querySkylineSet->noOfElt);
			for (j = 0; j < querySkylineSet->noOfElt; j++)
			{
				index[j] = j;
			}
			quicksort_i(index, elt, 0, querySkylineSet->noOfElt-1);
			for (j = 0; j < querySkylineSet->noOfElt; j++)
			{
				querySkylineSet->elt[j] = elt[querySkylineSet->noOfElt-1-j];
			}
			free(index);
			free(elt);
		}

		printf("Skyline (%d): ", querySkylineSet->noOfElt);
		set_print(stdout, querySkylineSet);
		printf("\n");

		//stat
		aStat.noOfQuerySkyline = querySkylineSet->noOfElt;

		set_free(querySkylineSet);
		free(querySkylineSet);
	}

#ifndef WIN32
	getrusage(RUSAGE_SELF,&query_end);
#endif

	fprintf(debugFilePtr, "%d\n", aStat.noOfTemplateSkyline);
	fprintf(debugFilePtr, "%d\n", aStat.noOfQuerySkyline);
	fprintf(debugFilePtr, "%d\n", aStat.noOfAffect);
	fprintf(debugFilePtr, "%d\n", aStat.noOfNonAffect);

#ifndef WIN32
	calculateExecutionTime(&preprocess_start, &preprocess_end,
			&qc_preprocess_time_u, &qc_preprocess_time_s);
	calculateExecutionTime(&preprocess_end, &query_end,
			&qc_query_time_u, &qc_query_time_s);
	qc_query_time_u /= aConfig->noOfFullOrderQuery;
	qc_query_time_s /= aConfig->noOfFullOrderQuery;

	fprintf(timeFilePtr, "%.10f\t%.10f\n", qc_preprocess_time_u,
			qc_preprocess_time_s);
	fprintf(timeFilePtr, "%.10f\t%.10f\n", qc_query_time_u,
			qc_query_time_s);

	printf("building time: %.10f\t%.10f\n", qc_preprocess_time_u,
			qc_preprocess_time_s);
	printf("querying time: %.10f\t%.10f\n", qc_query_time_u,
			qc_query_time_s);
#endif
}
