
#ifndef SFS_H
#define SFS_H

#include <stdio.h>
#include <stdlib.h>

#ifndef WIN32
#include <sys/resource.h>
#include <sys/times.h>
#include <unistd.h>
#endif

#include "set.h"
#include "config.h"
#include "qsort.h"
#include "set.h"

struct sfs_stat_s
{
	int noOfTemplateSkyline;
	int noOfQuerySkyline;
	int noOfAffect;
	int noOfNonAffect;
};

typedef struct sfs_stat_s sfs_stat;


void sfs_main(config *aConfig, mySet *remainD, mySet *globalSkyline, FILE *debugFilePtr, FILE *timeFilePtr);

void sfsBaseline_main(config *aConfig, mySet *remainD, mySet *globalSkyline, FILE *debugFilePtr, FILE *timeFilePtr);

void sfsNaive_main(config *aConfig, mySet *remainD, mySet *globalSkyline, FILE *debugFilePtr, FILE *timeFilePtr);

#ifndef WIN32
extern void calculateExecutionTime(struct rusage *myTime1, struct rusage *myTime2, float *userTime, float *sysTime);
#endif

#endif
